; Version 1.1

%include ".\equates.inc"

GLOBAL PB_StdIn

Extern lpszText
Extern lpszBuffer
Extern ConsoleTitle
Extern hInput
Extern bRead

Extern PB_StringBase
Extern _GetStdHandle@4
Extern _ReadFile@20
Extern _SetConsoleMode@8

%include ".\scmacro.mac"

SEGMENT .text USE32 CLASS=CODE

PB_StdIn:
    mov dword [stringmode], 0
    test eax, eax
    jnz .mem
    mov eax, [esp+4]
    mov dword [stringmode], 1
  .mem:
    mov [lpszText], eax
    sc GetStdHandle,STD_INPUT_HANDLE
    mov [hInput], eax
    sc SetConsoleMode,[hInput],ENABLE_LINE_INPUT|ENABLE_ECHO_INPUT|ENABLE_PROCESSED_INPUT
    push ecx
    push ebx
  .read:
    sc ReadFile,[hInput],[lpszBuffer],BufferSize-1,bRead,0
    test eax, eax
    jz .end
    cmp dword [bRead], 0
    je .end
    mov eax, [lpszBuffer]
    mov edx, [lpszText]
    mov ecx, [bRead]
  .copy:
    mov bl, [eax]
    inc eax
    mov [edx], bl
    inc edx
    dec ecx
    test ecx, ecx
    jnz .copy
    mov [lpszText], edx
    jmp .read
  .end:
    pop ebx
    pop ecx
    mov edx, [lpszText]
    mov eax, [esp+4]
    cmp dword [stringmode], 0
    je .nostring
    sub edx, eax
    add [PB_StringBase], edx
  .nostring:
    ret

[section .bss]

stringmode: resd 1
