; Version 1.1

%include ".\equates.inc"

GLOBAL PB_URLEncode

Extern PB_StringBase

SEGMENT .text USE32 CLASS=CODE

PB_URLEncode:
    mov dword edx, [esp+4]
    push ecx
    push ebx
    xor ebx, ebx
  .rizo:
    xor ecx, ecx
    mov cl, [eax]
    cmp cl, " "
    jne .seguir
    mov byte [edx], "+"
    inc eax
    inc edx
    jmp .rizo
  .seguir:
    mov [edx], cl
    test cl, cl
    jz .fin
    lea ecx, [HexTable+ecx*2]
    mov word bx, [ecx]
    test bx, bx
    jnz .codificar
    inc eax
    inc edx
    jmp .rizo
  .codificar:
    mov byte [edx], "%"
    inc edx
    mov [edx], bl
    inc edx
    mov [edx], bh
    inc eax
    inc edx
    jmp .rizo
  .fin:
    pop ebx
    pop ecx
    mov eax, [esp+4]
    sub edx, eax
    add [PB_StringBase], edx
    ret

[section .data]

HexTable:
db "000102030405060708090A0B0C0D0E0F"
db "101112131415161718191A1B1C1D1E1F"
db 0,0,"212223242526272829",0,0,"2B2C",0,0,0,0,"2F"
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"3A3B3C3D3E3F"
db "40",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"5B5C5D5E",0,0
db "60",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"7B7C7D7E7F"
db "808182838485868788898A8B8C8D8E8F"
db "909192939495969798999A9B9C9D9E9F"
db "A0A1A2A3A4A5A6A7A8A9AAABACADAEAF"
db "B0B1B2B3B4B5B6B7B8B9BABBBCBDBEBF"
db "C0C1C2C3C4C5C6C7C8C9CACBCCCDCECF"
db "D0D1D2D3D4D5D6D7D8D9DADBDCDDDEDF"
db "E0E1E2E3E4E5E6E7E8E9EAEBECEDEEEF"
db "F0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFF"
